/* PSDumb v0.1*/

/* begin setup */
EOF = x2c(4)
buffer = 1000000 /* buffer in byte */
/* end setup */

/* get working dir*/
oldpath = directory()

/* create a tempfilename */
tempdir = value(TEMP,,'OS2ENVIRONMENT')
if tempdir = 'TEMP' then tempdir = value(TMP,,'OS2ENVIRONMENT')
if tempdir = 'TMP' then tempdir = directory()
rc = directory(tempdir)
if rc = 0 then do
say "Error: invalid temp directory: " tempdir
signal exit
end
if lastpos('\', tempdir) >< length(tempdir) then tempdir = tempdir||'\'

do i = 0 to 999
 Select
  when length(i) = 1 then ext = '00'||i
  when length(i) = 2 then ext = '0'||i
  when length(i) = 3 then ext = i
 otherwise NOP
 end /*select*/

 tempfile = "postscript."||ext
  if stream(tempfile, "C", "QUERY EXISTS") = "" then leave
end
if i = 1000 then do
say "Error: maximum of 999 temporary postscript files detected."
signal EXIT
end

say "start PostScript write routine"

/* waiting for PostScript data */

say "waiting for PostScript header ..."
do forever
ps_line = linein()
if substr(ps_line,1,4) = "%!PS" then leave
end


/* writing PostScript file */

say "... found!"
say "write PostScript file ..."
rc = lineout(tempfile, ps_line)    /* write header*/
do forever
ps_char = charin(,,buffer)
	/* check EOF */
	if pos(EOF, ps_char) > 0  then leave
	else rc = charout(tempfile, ps_char)
end
say "found end of PostScript file"
rc = charout(tempfile, substr(ps_char,1,pos(EOF, ps_char)))
say "close PostScript file"
rc=stream(tempfile,'c','close')
/* start PS2PDF */
rc = directory(oldpath)

"@start PS2PDF.EXE" tempdir||tempfile
Say "exit PostScript write routine"
Say ""
Say "waiting for next print job..."
Say ""
EXIT:
"@exit"